local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

local remainingKegSmashCD
a.keepupShuffle = function()
	remainingKegSmashCD = s.SpellCooldown(121253--[[Keg Smash]])
	if (remainingKegSmashCD + 2 ) < x.ShuffleDuration then
		return true
	end
	if ((x.Chi - 2) >= 2) and x.ShuffleDuration > 1 then
		return true
	end
	if ((x.Chi - 2) == 1) and x.ShuffleDuration > 2 then
		return true
	end
	if ((x.Chi - 2) == 0) and x.ShuffleDuration > 3 then
		return true
	end
	return false
end

local regenRate
a.energyRegeneration = function()
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	if s.Buff(115288--[[Energizing Brew]], "player") then
		regenRate = regenRate + 10
	end
	return regenRate
end

local HasteCDs = {
	49016--[[Unholy Frenzy]],
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
	26297--[[Berserking]],
	3045--[[Rapid Fire]],
	105919--[[Chronohunter]],
}
a.Hasted = function()
	return s.Buff(HasteCDs, "player")
end

-- Detect raid-wide haste buffs, so we know when to
-- use potions
local BloodlustSpells = {
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
}
a.Bloodlust = function()
	return s.Buff(BloodlustSpells, "player")
end

a.MySelf = UnitGUID("player")

local LastAoETimestamp = 0
local CurrentTimestamp = 0
local LastAoETargetsHit = 0
local event, sourceGUID, spellId
a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, _, _, _, _, _, _, _, spellId = ...
	if sourceGUID == a.MySelf and (event == "SPELL_DAMAGE" or event == "SPELL_MISSED") then
		if CurrentTimestamp == LastAoETimestamp then
			LastAoETargetsHit = LastAoETargetsHit + 1
		else
			LastAoETargetsHit = 1
			LastAoETimestamp = CurrentTimestamp
		end
	end
end
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)

-- Check if we are in AoE mode
a.AoE = function()
	if CurrentTimestamp < LastAoETimestamp + 3 then
		return LastAoETargetsHit > 4
	else
		return false
	end
end